/*
	΂wPrhnAGR[h^fR[h

	minwΉ
*/

#define USE_STOPBIT_2_FOR_OVR_CHECK 0

#include <windows.h>
#include <string.h>
#include <stdio.h>

/*-------------------- encode/decode format ---------------------*/
/* encode nibble to TX byte */
static unsigned char encode_nibble(unsigned char data)
{
	int nib;
#if 1
	/* 4bit part2 */
	nib = 0x80;
	if(data&1)
		nib |= 0x01;
	if(data&2)
		nib |= 0x06;
	if(data&4)
		nib |= 0x18;
	if(data&8)
		nib |= 0x60;
#else
	/* 5bit */
	nib = 0x80;
	if(data&1)
		nib |= 0x01;
	if(data&2)
		nib |= 0x02;
	if(data&4)
		nib |= 0x04;
	if(data&8)
		nib |= 0x18;
#endif
	return nib;
}

/* decode nibble from RX byte */
static unsigned char decode_nibble(unsigned char data)
{
	int nib;

#if 1
	nib = 0;
	if(data&0x01)
		nib |= 0x01;
	if(data&0x02)
		nib |= 0x02;
	if(data&0x08)
		nib |= 0x04;
	if(data&0x20)
		nib |= 0x08;
#else
	/* 5bit */
	nib = data & 0x0f;
#endif
	return nib;
}

/*-------------------- file access routine ---------------------*/

/* RS232C interface */
HANDLE file_open(char *name,int baudrate)
{
	HANDLE hndl;
	BOOL success;
	DCB dcb;
	int comflag = 1;
	char filename[256];
	DWORD fdwCreate;

	if(strncmp(name,"COM",3) == 0)
	{ /* COM port */
		sprintf(filename,"\\\\.\\%s",name);
		comflag = 1;
		fdwCreate = OPEN_EXISTING;
	}
	else
	{ /* FILE */
		strcpy(filename,name);
		comflag = 0;
		fdwCreate = OPEN_ALWAYS;
	}
	hndl = CreateFile(filename,GENERIC_READ|GENERIC_WRITE,
		0,0,fdwCreate,FILE_ATTRIBUTE_NORMAL,0);

	if( hndl != INVALID_HANDLE_VALUE && comflag)
	{
		success = GetCommState(hndl,&dcb);
		if(success)
		{
			/* baudrate ˑ */
			switch(baudrate)
			{
			case 115200:
				dcb.BaudRate = CBR_115200;
				dcb.ByteSize = 7;
				break;
			case 9600:
				dcb.BaudRate = CBR_9600;
				dcb.ByteSize = 8;
				break;
			default:
				dcb.BaudRate = baudrate;
				dcb.ByteSize = 8;
				break;
			}
			dcb.fBinary = TRUE;
			dcb.fParity = FALSE;
			dcb.fOutxCtsFlow = TRUE;
			dcb.fOutxDsrFlow = FALSE;
			dcb.fDtrControl = DTR_CONTROL_ENABLE;
			dcb.fDsrSensitivity = FALSE;
			dcb.fTXContinueOnXoff = FALSE;
			dcb.fNull = FALSE;
			dcb.fRtsControl = RTS_CONTROL_HANDSHAKE;
			dcb.Parity = NOPARITY;
#if USE_STOPBIT_2_FOR_OVR_CHECK
			dcb.StopBits = TWOSTOPBIT;
#else
			dcb.StopBits = ONESTOPBIT;
#endif
			success = SetCommState(hndl,&dcb);
			if(success)
			{
				SetCommMask(hndl,EV_TXEMPTY);
				return hndl;
			}
		}
		CloseHandle(hndl);
		hndl = INVALID_HANDLE_VALUE;
	}
	return hndl;
}

void file_close(HANDLE hndl)
{
	DWORD event;

	if( SetCommMask(hndl,EV_TXEMPTY) )
	{
		WaitCommEvent(hndl,&event,NULL);
		Sleep(100);
	}
	CloseHandle(hndl);
}

int file_write(HANDLE hndl,void *data,int size)
{
	DWORD write_size;
	if( WriteFile(hndl,data,size,&write_size,NULL) == TRUE )
		return write_size;
	return 0;
}

int file_read(HANDLE hndl,void *data,int size)
{
	DWORD read_size;
	if( ReadFile(hndl,data,size,&read_size,NULL) == TRUE )
		return read_size;
	return 0;
}

int file_size(HANDLE hndl)
{
	return GetFileSize(hndl,NULL);
}


/*-------------------- copy/encode/decode routine ---------------------*/
#define BUF_SIZE 2048
static unsigned char buf[BUF_SIZE];

static void copy_file(HANDLE src,HANDLE dst,int startad)
{
	int num;
	int endp;

	while(1)
	{
		/* SRC */
		if( startad != -1)
		{	/* loadm header add */
			buf[BUF_SIZE/2+0] = (unsigned char)startad;
			buf[BUF_SIZE/2+1] = (unsigned char)(startad / 256);
			endp = startad + file_size(src);
			buf[BUF_SIZE/2+2] = (unsigned char)endp;
			buf[BUF_SIZE/2+3] = (unsigned char)(endp / 256);
			num=4;
			printf("Make LOADM Header start=%04x end=%04x\n",startad,endp);
			startad = -1;
		}
		else
		{
			num = file_read(src,&buf[0],BUF_SIZE);
			if( num == 0)
			{
				return;
			}
		}
		/* DST */
		printf(".");
		file_write(dst,buf,num);
	}
}

static void encode_file(HANDLE src,HANDLE dst,int startad)
{
	unsigned char data , d1 , d2;
	int num;
	int i;
	int endp;

	while(1)
	{
		if( startad != -1)
		{	/* loadm header add */
			buf[BUF_SIZE/2+0] = (unsigned char)startad;
			buf[BUF_SIZE/2+1] = (unsigned char)(startad / 256);
			endp = startad + file_size(src);
			buf[BUF_SIZE/2+2] = (unsigned char)endp;
			buf[BUF_SIZE/2+3] = (unsigned char)(endp / 256);
			num=4;
			printf("Make LOADM Header start=%04x end=%04x\n",startad,endp);
			startad = -1;
		}
		else
		{
			num = file_read(src,&buf[BUF_SIZE/2],BUF_SIZE/2);
			if( num == 0)
			{
				return;
			}
		}
		/* encode */
		for(i=0;i<num;i++)
		{
			data = buf[BUF_SIZE/2+i];
			buf[i*2] = encode_nibble(data);
			buf[i*2+1] = encode_nibble(data>>4);
		}
		printf(".");
		file_write(dst,buf,num*2);
	}
}

/* decode */
static void decode_file(HANDLE src,HANDLE dst,int startad)
{
	unsigned char data , d1 , d2;
	int num;
	int i;

	while(1)
	{
		num = file_read(src,&buf[0],BUF_SIZE);
		if( num == 0)
			return;
		printf(".");
		/* encode */
		for(i=0;i<num;i+=2)
		{
			d1 = buf[i];
			d2 = buf[i+1];
			data = (decode_nibble(d2)<<4) + decode_nibble(d1);
			buf[i/2] = data;
		}
		file_write(dst,buf,num/2);
	}
}

int main( int argc , char *argv[] )
{
	int err=0;
	char *argp;
	char filename[2][128];
	HANDLE fsrc,fdst;
	int startad , baudrate;
	int cmd = 0;
	int i;

	baudrate = 115200;
	startad = -1;
	filename[0][0] = filename[1][0] = 0x00;

	/* command code */
	if( argc<2)
		err = 1;
	else
		cmd = argv[1][0] | 0x20;
	/* option anaryze */
	for(i=2; i<argc && !err; i++){
		argp = argv[i];
		if( *argp =='/' || *argp=='-')
		{	/* option switch */
			argp++;
			switch(*argp++ | 0x20)
			{
			case 'h': /* add LOADM header and set start address */
				if(sscanf(argp,"%x",&startad)<1)
					err=1;
				break;
			case 'b': /* baudrate */
				if(sscanf(argp,"%d",&baudrate)<1)
					err=1;
				break;

			default:
				err = 1;
			}
		}
		else
		{
			if(filename[0][0] == 0)
				strcpy(filename[0],argp);
			else if(filename[1][0] == 0)
				strcpy(filename[1],argp);
			else
				err=1;
		}
	}
	switch(cmd)
	{
	case 'c':
	case 'e':
	case 'd':
		if( !filename[0][0] || !filename[1][0])
			err = 1;
		break;
	default:
		err = 1;
	}
	if(err==1)
	{
		printf("\
  usage x1term [command] [src_name] [dst_name] [-option]\n\n\
  command:\n\
    C : copy src_name to dst_name \n\
    E : copy src_name to dst_name with Hispeed encode\n\
    D : copy src_name to dst_name with Hispeed decode\n\
  option:              |cmd|defallt| note\n\
    -h[start_address]  |all|(auto) | add LOADM header with start_address\n\
    -b[baudrate]       |all|115200 | baudrate for COMx device\n\
");
		return 1;
	}
	/* open source file */
	fsrc = file_open(filename[0],baudrate);
	if(fsrc == INVALID_HANDLE_VALUE )
	{
		printf("Can't open source file '%s'\n",argv[2]);
		return 1;
	}
	/* distination file */
	fdst = file_open(filename[1],baudrate);
	if(fdst == INVALID_HANDLE_VALUE )
	{
		printf("Can't open destination file '%s'\n",argv[3]);
		file_close(fsrc);
		return 1;
	}

	switch(cmd)
	{
	case 'c': // ̃Rs[
		copy_file(fsrc,fdst,startad);
		break;
	case 'e': // GR[hiMj
		encode_file(fsrc,fdst,startad);
		break;
	case 'd': // fR[hiMj
		decode_file(fsrc,fdst,startad);
		break;
	}
	file_close(fsrc);
	file_close(fdst);
	printf("\nfinish!\n");
	return 0;
}